diff --git a/storage/innobase/trx/trx0trx.cc b/storage/innobase/trx/trx0trx.cc
index 4af1f5d..b2ce5af 100644
--- a/storage/innobase/trx/trx0trx.cc
+++ b/storage/innobase/trx/trx0trx.cc
@@ -1980,6 +2614,7 @@ written */
 
   ut_a(trx->error_state == DB_SUCCESS);
 }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 /** Commits a transaction and a mini-transaction. */
 void trx_commit_low(
@@ -2013,12 +2648,18 @@ void trx_commit_low(
     }
   }
 
+#ifndef HAVE_LOCK_FREE_READVIEW
   bool serialised;
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   if (mtr != NULL) {
     mtr->set_sync();
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+    trx_write_serialisation_history(trx, mtr);
+#else
     serialised = trx_write_serialisation_history(trx, mtr);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
     /* The following call commits the mini-transaction, making the
     whole transaction committed in the file-based world, at this
@@ -2056,7 +2697,9 @@ void trx_commit_low(
     /*--------------*/
 
   } else {
+#ifndef HAVE_LOCK_FREE_READVIEW
     serialised = false;
+#endif /* HAVE_LOCK_FREE_READVIEW */
   }
 #ifdef UNIV_DEBUG
   /* In case of this function is called from a stack executing
@@ -2072,7 +2715,11 @@ void trx_commit_low(
   }
 #endif
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  trx_commit_in_memory(trx, mtr);
+#else
   trx_commit_in_memory(trx, mtr, serialised);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 }
 
 /** Commits a transaction. */
@@ -2098,6 +2745,7 @@ void trx_commit(trx_t *trx) /*!< in/out: transaction */
   trx_commit_low(trx, mtr);
 }
 
+#ifndef HAVE_LOCK_FREE_READVIEW
 /** Cleans up a transaction at database startup. The cleanup is needed if
  the transaction already got to the middle of a commit when the database
  crashed, and we cannot roll it back. */
@@ -2155,6 +2803,7 @@ ReadView *trx_assign_read_view(trx_t *trx) /*!< in/out: active transaction */
 
   return (trx->read_view);
 }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 /** Prepares a transaction for commit/rollback. */
 void trx_commit_or_rollback_prepare(trx_t *trx) /*!< in/out: transaction */
@@ -2377,7 +3026,9 @@ void trx_print_low(FILE *f,
   ibool newline;
   const char *op_info;
 
+#ifndef HAVE_LOCK_FREE_READVIEW
   ut_ad(trx_sys_mutex_own());
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   fprintf(f, "TRANSACTION " TRX_ID_FMT, trx_get_id_for_print(trx));
 
@@ -2494,7 +3145,9 @@ void trx_print_latched(
                          or 0 to use the default max length */
 {
   ut_ad(lock_mutex_own());
+#ifndef HAVE_LOCK_FREE_READVIEW
   ut_ad(trx_sys_mutex_own());
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   trx_print_low(f, trx, max_query_len, lock_number_of_rows_locked(&trx->lock),
                 UT_LIST_GET_LEN(trx->lock.trx_locks),
@@ -2518,11 +3171,15 @@ void trx_print(FILE *f,             /*!< in: output stream */
   heap_size = mem_heap_get_size(trx->lock.lock_heap);
   lock_mutex_exit();
 
+#ifndef HAVE_LOCK_FREE_READVIEW
   mutex_enter(&trx_sys->mutex);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   trx_print_low(f, trx, max_query_len, n_rec_locks, n_trx_locks, heap_size);
 
+#ifndef HAVE_LOCK_FREE_READVIEW
   mutex_exit(&trx_sys->mutex);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 }
 
 #ifdef UNIV_DEBUG
@@ -2531,7 +3188,9 @@ void trx_print(FILE *f,             /*!< in: output stream */
  @return true if started */
 ibool trx_assert_started(const trx_t *trx) /*!< in: transaction */
 {
+#ifndef HAVE_LOCK_FREE_READVIEW
   ut_ad(trx_sys_mutex_own());
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   /* Non-locking autocommits should not hold any locks and this
   function is only called from the locking code. */
@@ -2681,6 +3340,15 @@ static void trx_prepare(trx_t *trx) /*!< in/out: transaction */
 
   /*--------------------------------------*/
   ut_a(trx->state == TRX_STATE_ACTIVE);
+#ifdef HAVE_LOCK_FREE_READVIEW
+  trx_mutex_enter(trx);
+  trx->state = TRX_STATE_PREPARED;
+  /* Add GTID to be persisted to disk table, if needed. */
+  if (gtid_desc.m_is_set) {
+    gtid_persistor.add(gtid_desc);
+  }
+  trx_mutex_exit(trx);
+#else
   trx_sys_mutex_enter();
   trx->state = TRX_STATE_PREPARED;
   trx_sys->n_prepared_trx++;
@@ -2689,6 +3357,7 @@ static void trx_prepare(trx_t *trx) /*!< in/out: transaction */
     gtid_persistor.add(gtid_desc);
   }
   trx_sys_mutex_exit();
+#endif /* HAVE_LOCK_FREE_READVIEW */
   /*--------------------------------------*/
   DEBUG_SYNC_C("trx_prepare_has_changed_state");
 
@@ -2830,6 +3499,123 @@ static bool get_info_about_prepared_transaction(XA_recover_txn *txn_list,
   return false;
 }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+struct trx_recover_for_mysql_callback_arg {
+  XA_recover_txn *txn_list;
+  MEM_ROOT *mem_root;
+  ulint len;
+  ulint count;
+};
+
+static bool trx_recover_for_mysql_callback(
+    rw_trx_hash_element_t *element, trx_recover_for_mysql_callback_arg *arg) {
+  mutex_enter(&element->mutex);
+  trx_t *trx = element->trx;
+  if (trx != nullptr) {
+    /* The state of a read-write transaction cannot change
+    from or to NOT_STARTED while we are holding the
+    trx_sys->mutex. It may change to PREPARED, but not if
+    trx->is_recovered. It may also change to COMMITTED. */
+    if (trx_state_eq(trx, TRX_STATE_PREPARED)) {
+      if (get_info_about_prepared_transaction(&arg->txn_list[arg->count], trx,
+                                              arg->mem_root)) {
+        mutex_exit(&element->mutex);
+        return true;
+      }
+
+      if (arg->count == 0) {
+        ib::info(ER_IB_MSG_1207) << "Starting recovery for"
+                                    " XA transactions...";
+      }
+
+      ib::info(ER_IB_MSG_1208) << "Transaction " << trx_get_id_for_print(trx)
+                               << " in prepared state after recovery";
+
+      ib::info(ER_IB_MSG_1209)
+          << "Transaction contains changes to " << trx->undo_no << " rows";
+
+      arg->txn_list[arg->count++].id = *trx->xid;
+    }
+  }
+  mutex_exit(&element->mutex);
+  return (arg->count == arg->len);
+}
+
+/** This function is used to find number of prepared transactions and
+ their transaction objects for a recovery.
+ @return number of prepared transactions stored in xid_list */
+int trx_recover_for_mysql(
+    XA_recover_txn *txn_list, /*!< in/out: prepared transactions */
+    ulint len,                /*!< in: number of slots in xid_list */
+    MEM_ROOT *mem_root)       /*!< in: memory for table names */
+{
+  ut_ad(txn_list != nullptr);
+  ut_ad(len > 0);
+
+  trx_recover_for_mysql_callback_arg arg = {txn_list, mem_root, len, 0U};
+
+  /* Fill txb_list with PREPARED transactions. */
+  trx_sys->rw_trx_hash.iterate_no_dups(
+      reinterpret_cast<lf_hash_walk_func *>(trx_recover_for_mysql_callback),
+      &arg);
+
+  if (arg.count > 0) {
+    ib::info(ER_IB_MSG_1210) << arg.count
+                             << " transactions in prepared state"
+                                " after recovery";
+  }
+
+  return (static_cast<int>(arg.count));
+}
+
+struct trx_get_trx_by_xid_callback_arg {
+  const XID *xid;
+  trx_t *trx;
+};
+
+static bool trx_get_trx_by_xid_callback(rw_trx_hash_element_t *element,
+                                        trx_get_trx_by_xid_callback_arg *arg) {
+  bool found = false;
+
+  mutex_enter(&element->mutex);
+  trx_t *trx = element->trx;
+  if (trx != nullptr) {
+    /* Compare two X/Open XA transaction id's: their
+    length should be the same and binary comparison
+    of gtrid_length+bqual_length bytes should be
+    the same */
+
+    if (trx->is_recovered && trx_state_eq(trx, TRX_STATE_PREPARED) &&
+        arg->xid->eq(trx->xid)) {
+      /* Invalidate the XID, so that subsequent calls
+      will not find it. */
+      trx->xid->reset();
+      arg->trx = trx;
+      found = true;
+    }
+  }
+  mutex_exit(&element->mutex);
+
+  return found;
+}
+
+/** This function is used to find one X/Open XA distributed transaction
+ which is in the prepared state
+ @return trx or NULL; on match, the trx->xid will be invalidated;
+ note that the trx may have been committed, unless the caller is
+ holding lock_sys->mutex */
+trx_t *trx_get_trx_by_xid(
+    const XID *xid) /*!< in: X/Open XA transaction identifier */
+{
+  trx_get_trx_by_xid_callback_arg arg = {xid, nullptr};
+  if (xid != nullptr) {
+    trx_sys->rw_trx_hash.iterate(
+        reinterpret_cast<lf_hash_walk_func *>(trx_get_trx_by_xid_callback),
+        &arg);
+  }
+  return arg.trx;
+}
+#else
 /** This function is used to find number of prepared transactions and
  their transaction objects for a recovery.
  @return number of prepared transactions stored in xid_list */
@@ -2949,6 +3735,7 @@ trx_t *trx_get_trx_by_xid(
 
   return (trx);
 }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 /** Starts the transaction if it is not yet started. */
 void trx_start_if_not_started_xa_low(
@@ -2963,10 +3750,17 @@ void trx_start_if_not_started_xa_low(
 
     case TRX_STATE_ACTIVE:
       if (trx->id == 0 && read_write) {
-        /* If the transaction is tagged as read-only then
-        it can only write to temp tables and for such
-        transactions we don't want to move them to the
-        trx_sys_t::rw_trx_list. */
+#ifdef HAVE_LOCK_FREE_READVIEW
+      /* If the transaction is tagged as read-only then
+      it can only write to temp tables and for such
+      transactions we don't want to move them to the
+      trx_sys_t::rw_trx_hash. */
+#else
+      /* If the transaction is tagged as read-only then
+      it can only write to temp tables and for such
+      transactions we don't want to move them to the
+      trx_sys_t::rw_trx_list. */
+#endif /* HAVE_LOCK_FREE_READVIEW */
         if (!trx->read_only) {
           trx_set_rw_mode(trx);
         } else if (!srv_read_only_mode) {
@@ -3044,7 +3838,9 @@ void trx_start_internal_read_only_low(trx_t *trx) {
 void trx_set_rw_mode(trx_t *trx) /*!< in/out: transaction that is RW */
 {
   ut_ad(trx->rsegs.m_redo.rseg == 0);
+#ifndef HAVE_LOCK_FREE_READVIEW
   ut_ad(!trx->in_rw_trx_list);
+#endif /* HAVE_LOCK_FREE_READVIEW */
   ut_ad(!trx_is_autocommit_non_locking(trx));
   ut_ad(!trx->read_only);
 
@@ -3063,6 +3859,20 @@ void trx_set_rw_mode(trx_t *trx) /*!< in/out: transaction that is RW */
 
   ut_ad(trx->rsegs.m_redo.rseg != 0);
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+    trx_sys->register_rw(trx);
+
+  /* So that we can see our own changes. */
+  if (trx->read_view.is_open()) {
+    trx->read_view.set_creator_trx_id(trx->id);
+  }
+
+#ifdef UNIV_DEBUG
+  if (trx->id > trx_sys->rw_max_trx_no) {
+    trx_sys->rw_max_trx_no = trx->id;
+  }
+#endif /* UNIV_DEBUG */
+#else
   mutex_enter(&trx_sys->mutex);
 
   ut_ad(trx->id == 0);
@@ -3082,6 +3892,7 @@ void trx_set_rw_mode(trx_t *trx) /*!< in/out: transaction that is RW */
   ut_d(trx->in_rw_trx_list = true);
 
   mutex_exit(&trx_sys->mutex);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 }
 
 void trx_kill_blocking(trx_t *trx) {
diff --git a/storage/innobase/trx/trx0undo.cc b/storage/innobase/trx/trx0undo.cc
index 7503d11..f963972 100644
--- a/storage/innobase/trx/trx0undo.cc
+++ b/storage/innobase/trx/trx0undo.cc
@@ -1885,6 +1885,71 @@ void trx_undo_insert_cleanup(trx_undo_ptr_t *undo_ptr, bool noredo) {
   mutex_exit(&(rseg->mutex));
 }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+/** At shutdown, frees the undo logs of a transaction. */
+void trx_undo_free_at_shutdown(trx_t *trx) {
+  if (trx->rsegs.m_redo.update_undo != nullptr) {
+    switch (trx->rsegs.m_redo.update_undo->state) {
+      case TRX_UNDO_PREPARED:
+        break;
+      case TRX_UNDO_CACHED:
+      case TRX_UNDO_TO_FREE:
+      case TRX_UNDO_TO_PURGE:
+      case TRX_UNDO_ACTIVE:
+        ut_ad(trx_state_eq(trx, TRX_STATE_COMMITTED_IN_MEMORY));
+        break;
+      default:
+        ut_error;
+    }
+
+    UT_LIST_REMOVE(trx->rsegs.m_redo.rseg->update_undo_list,
+                   trx->rsegs.m_redo.update_undo);
+    trx_undo_mem_free(trx->rsegs.m_redo.update_undo);
+
+    trx->rsegs.m_redo.update_undo = nullptr;
+  }
+
+  if (trx->rsegs.m_redo.insert_undo != nullptr) {
+    switch (trx->rsegs.m_redo.insert_undo->state) {
+      case TRX_UNDO_PREPARED:
+        break;
+      case TRX_UNDO_CACHED:
+      case TRX_UNDO_TO_FREE:
+      case TRX_UNDO_TO_PURGE:
+      case TRX_UNDO_ACTIVE:
+        ut_ad(trx_state_eq(trx, TRX_STATE_COMMITTED_IN_MEMORY));
+        break;
+      default:
+        ut_error;
+    }
+
+    UT_LIST_REMOVE(trx->rsegs.m_redo.rseg->insert_undo_list,
+                   trx->rsegs.m_redo.insert_undo);
+    trx_undo_mem_free(trx->rsegs.m_redo.insert_undo);
+
+    trx->rsegs.m_redo.insert_undo = nullptr;
+  }
+
+  if (trx->rsegs.m_noredo.update_undo != nullptr) {
+    ut_a(trx->rsegs.m_noredo.update_undo->state == TRX_UNDO_PREPARED);
+
+    UT_LIST_REMOVE(trx->rsegs.m_noredo.rseg->update_undo_list,
+                   trx->rsegs.m_noredo.update_undo);
+    trx_undo_mem_free(trx->rsegs.m_noredo.update_undo);
+
+    trx->rsegs.m_noredo.update_undo = nullptr;
+  }
+  if (trx->rsegs.m_noredo.insert_undo != nullptr) {
+    ut_a(trx->rsegs.m_noredo.insert_undo->state == TRX_UNDO_PREPARED);
+
+    UT_LIST_REMOVE(trx->rsegs.m_noredo.rseg->insert_undo_list,
+                   trx->rsegs.m_noredo.insert_undo);
+    trx_undo_mem_free(trx->rsegs.m_noredo.insert_undo);
+
+    trx->rsegs.m_noredo.insert_undo = nullptr;
+  }
+}
+#else
 /** At shutdown, frees the undo logs of a PREPARED transaction. */
 void trx_undo_free_prepared(trx_t *trx) /*!< in/out: PREPARED transaction */
 {
@@ -1927,6 +1992,7 @@ void trx_undo_free_prepared(trx_t *trx) /*!< in/out: PREPARED transaction */
     trx->rsegs.m_noredo.insert_undo = NULL;
   }
 }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 bool trx_undo_truncate_tablespace(undo::Tablespace *marked_space) {
 #ifdef UNIV_DEBUG
diff --git a/storage/innobase/ut/ut0new.cc b/storage/innobase/ut/ut0new.cc
index 46ce424..815803f 100644
--- a/storage/innobase/ut/ut0new.cc
+++ b/storage/innobase/ut/ut0new.cc
@@ -54,7 +54,9 @@ PSI_memory_key mem_key_partitioning;
 PSI_memory_key mem_key_row_log_buf;
 PSI_memory_key mem_key_row_merge_sort;
 PSI_memory_key mem_key_std;
+#ifndef HAVE_LOCK_FREE_READVIEW
 PSI_memory_key mem_key_trx_sys_t_rw_trx_ids;
+#endif /* HAVE_LOCK_FREE_READVIEW */
 PSI_memory_key mem_key_undo_spaces;
 PSI_memory_key mem_key_ut_lock_free_hash_t;
 /* Please obey alphabetical order in the definitions above. */
@@ -94,8 +96,10 @@ static PSI_memory_info pfs_info[] = {
     {&mem_key_row_log_buf, "row_log_buf", 0, 0, PSI_DOCUMENT_ME},
     {&mem_key_row_merge_sort, "row_merge_sort", 0, 0, PSI_DOCUMENT_ME},
     {&mem_key_std, "std", 0, 0, PSI_DOCUMENT_ME},
+#ifndef HAVE_LOCK_FREE_READVIEW
     {&mem_key_trx_sys_t_rw_trx_ids, "trx_sys_t::rw_trx_ids", 0, 0,
      PSI_DOCUMENT_ME},
+#endif /* HAVE_LOCK_FREE_READVIEW */
     {&mem_key_undo_spaces, "undo::Tablespaces", 0, 0, PSI_DOCUMENT_ME},
     {&mem_key_ut_lock_free_hash_t, "ut_lock_free_hash_t", 0, 0,
      PSI_DOCUMENT_ME},
diff --git a/unittest/gunit/mysys_lf-t.cc b/unittest/gunit/mysys_lf-t.cc
index d658834..7a5a30d 100644
--- a/unittest/gunit/mysys_lf-t.cc
+++ b/unittest/gunit/mysys_lf-t.cc
@@ -122,10 +122,20 @@ extern "C" void *test_lf_alloc(void *arg) {
   return 0;
 }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+bool do_sum(void *num, void *acc) {
+  *static_cast<int *>(acc) += *static_cast<int *>(num);
+  return false;
+}
+#endif /* HAVE_LOCK_FREE_READVIEW */
 const int N_TLH = 1000;
 extern "C" void *test_lf_hash(void *arg) {
   int m = (*(int *)arg) / (2 * N_TLH);
+#ifdef HAVE_LOCK_FREE_READVIEW
+  int32 x, y, z, sum = 0, ins = 0, scans = 0;
+#else
   int32 x, y, z, sum = 0, ins = 0;
+#endif /* HAVE_LOCK_FREE_READVIEW */
   LF_PINS *pins;
 
   if (with_my_thread_init) my_thread_init();
@@ -142,6 +152,13 @@ extern "C" void *test_lf_hash(void *arg) {
         sum += z;
         ins++;
       }
+#ifdef HAVE_LOCK_FREE_READVIEW
+      else {
+        int unused = 0;
+        lf_hash_iterate(&lf_hash, pins, do_sum, &unused);
+        scans++;
+      }
+#endif /* HAVE_LOCK_FREE_READVIEW */
     }
     for (i = 0; i < N_TLH; i++) {
       y = (y * (m + i) + 0x87654321) & INT_MAX32;
-- 
1.8.3.1

